<template>
  <div class="stars">
    <h1 class="my-4 text-center">List of stars</h1>
    <div v-if="this.stars">
      <div class="mb-2">
        <FilterCheckbox
          :id="'checkedIsPlanet'"
          :label="'Only planets ?'"
          v-model="checkedIsPlanet"
          @update="onFilter"
        />
        <FilterCheckbox
          :id="'checkedHasMoons'"
          :label="'Has moons ?'"
          v-model="checkedHasMoons"
          @update="onFilter"
        />
      </div>
      <div class="row">
        <CardGroup :stars="filteredStars" />
      </div>
    </div>
    <div v-else class="text-center">
      <b-spinner label="Spinning"></b-spinner>
    </div>
  </div>
</template>

<script>
import CardGroup from "../../components/Card/CardGroup.vue";
import FilterCheckbox from "./../../components/Filter/FilterCheckbox.vue";
import StarsAPI from "../../services/index.js";

export default {
  name: "stars",
  components: {
    CardGroup,
    FilterCheckbox
  },
  data() {
    return {
      stars: [],
      checkedIsPlanet: false,
      checkedHasMoons: false
    };
  },
  computed: {
    filteredStars() {
      if (this.checkedIsPlanet && this.checkedHasMoons) {
        return this.stars
          .filter(star => star.isPlanet === true)
          .filter(star => star.moons !== null);
      }
      if (this.checkedIsPlanet) {
        return this.stars.filter(star => star.isPlanet === true);
      }
      if (this.checkedHasMoons) {
        return this.stars.filter(star => star.moons !== null);
      }

      return this.stars;
    }
  },
  methods: {
    onFilter(state) {
      state.id === "checkedIsPlanet" && (this.checkedIsPlanet = state.checked);
      state.id === "checkedHasMoons" && (this.checkedHasMoons = state.checked);
    }
  },
  mounted() {
    const favorites = this.$store.state.favorites.list;
    this.stars = this.stars.filter(p => favorites.includes(p.id));
  },
  async asyncData({ store }) {
    if (store.state.stars.list.length !== 0) {
      const stars = store.state.stars.list;
      return { stars };
    } else {
      const stars = await StarsAPI.findAll();
      store.commit("stars/set", stars);
      return { stars };
    }
  }
};
</script>
